/*
 * mDNSHooks.h
 * Liberté
 *
 * Copyright (c) 2005 Landon J. Fuller <landonf@opendarwin.org>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holder nor the names of contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef __MDNSHOOKS_H__
#define __MDNSHOOKS_H__

#include "Shout.h"

#include "mDNSEmbeddedAPI.h"

/*
 * Initialization
 */
void mDNSHooksInitialize(ShoutConfig *configPtr);

/*
 * mDNSResponder Overrides
 */

/* mDNS_Execute() */
#define mDNS_ExecuteSymbol "_mDNS_Execute"

typedef mDNSs32 (*mDNS_ExecutePtr)(mDNS *const m);

void mDNS_ExecuteInitialize(mDNS_ExecutePtr func);

mDNSs32 mDNS_ExecuteOverride(mDNS *const m);

/* mDNSAddrIsDNSMulticast */
#define mDNSAddrIsDNSMulticastSymbol "_mDNSAddrIsDNSMulticast"

typedef mDNSBool (*mDNSAddrIsDNSMulticastPtr)(const mDNSAddr *ip);

void mDNSAddrIsDNSMulticastInitialize(mDNSAddrIsDNSMulticastPtr func);

mDNSexport mStatus mDNSAddrIsDNSMulticastOverride(const mDNSAddr *ip);


/* mDNSPlatformSendUDP */
#define mDNSPlatformSendUDPSymbol "_mDNSPlatformSendUDP"

typedef mStatus (*mDNSPlatformSendUDPPtr)(const mDNS *const m,
										    const void *const msg,
										    const mDNSu8 *const end,
										    mDNSInterfaceID InterfaceID,
										    const mDNSAddr *dst,
										    mDNSIPPort dstPort);

void mDNSPlatformSendUDPInitialize(mDNSPlatformSendUDPPtr func);

mDNSexport mStatus mDNSPlatformSendUDPOverride(const mDNS *const m,
											    const void *const msg,
											    const mDNSu8 *const end,
											    mDNSInterfaceID InterfaceID,
											    const mDNSAddr *dst,
											    mDNSIPPort dstPort);
#endif /* __MDNSHOOKS_H__ */